#include<bits/stdc++.h>
using namespace std;
int o,a,b,ab,n,t[100000], zbiro,zbira,zbirb,zbirab;
string pacijenti[100000];
int main()
{
  zbiro=0;
  zbira=0;
  zbirb=0;
  zbirab=0;

  cin >> n;
  cin >> o >> a >> b >> ab;
  for(int i=0; i<n; i++)
  {
    cin >> pacijenti[i] >> t[i];
    if(pacijenti[i]=="O")
    {
      zbiro=zbiro+t[i];
    }

    if(pacijenti[i]=="A")
    {
      zbira=zbira+t[i];
    }

      if(pacijenti[i]=="B")
    {
      zbirb=zbirb+t[i];
    }

      if(pacijenti[i]=="AB")
    {
      zbirab=zbirab+t[i];
    }
  }



  if(zbiro>o)
  {
    cout << "nemoguce";
    return 0;
  }
  o=o-zbiro;





  if(a-zbira<0)
  {
    if((a+o)-zbira<0 )//a je kolko imam zbira kolko treba
    {
      cout << "nemoguce";
      o=o-a-zbira;
      zbira=zbira-a;
      return 0;
    }
  }
  zbira=zbira-a;







  if(b-zbirb<0)
  {
    if((b+o)-zbirb<0 )//a je kolko imam zbira kolko treba
    {
      cout << "nemoguce";
      o=o-(b-zbirb);
      zbirb=zbirb-b;
      return 0;
    }
  }
  zbirb=zbirb-b;












  if((ab+a+b+o)-zbirab<0)
  {
    cout << "nemoguce" << endl;
    return 0;
  }
  else
  {
    cout << "moguce" << endl;
  }

  return 0;
}
    // if((ab-zbirab)+(a-zbirab)+(b-zbirab)+(o-zbirab)<0)
    // {
    // cout << "nemoguce" << endl;
    // cout << ab << endl << zbirab << endl << o;
    // return 0;
    // }
    // else
    // {
    //   cout << "moguce";
    // }